<script setup lang="ts">
import { marked } from 'marked'
import { ref, watch } from 'vue'
import GitApiCall from '@/api/gitApi'
import PipelineSetupFormComponent from '@/components/gitlab/pipeline/setup/PipelineSetupFormComponent.vue'

const props = defineProps<{
  groupId: number
  projectId: number
  branch: string
  route: string
}>()

const fileContentData = ref({})
const disclaimerNote = ref('')
const errorMessage = ref<string>('')
const isError = ref<boolean>(false)
const markdownContent = ref('')
const git = new GitApiCall()

// Watchers
watch(() => props.projectId, getFormsMainContent)
watch(() => props.branch, getFormsMainContent)
watch(() => props.branch, getdisclaimer)

watch(() => props.branch, (newBranch, oldBranch) => {
  console.log('[PipelineSetupForm] Branch changed from', oldBranch, 'to', newBranch)
  getFormsMainContent()
})

async function getFormsMainContent() {
  console.log('Before get content condition props.projectId: ', props.projectId)
  if (props.projectId === 0)
    return

  try {
    const version = (window as any).UI_FORM_VERSION
    const fileName = version ? `main.${version}.json` : 'main.json'
    const filePath = `ui%2Fforms%2F${encodeURIComponent(fileName)}/raw?ref=${props.branch}`
    const response = await git.getFileContent(props.projectId.toString(), filePath)

    fileContentData.value = response.data
    console.log('getFormsMainContent fileContentData:', fileContentData)
    if (Array.isArray(fileContentData)) {
      isError.value = true
      errorMessage.value = 'JSON format is incorrect'
      Object.assign(fileContentData, {})
    }
    console.log('getFormsMainContent fileContentData:', fileContentData)
  }
  catch (error) {
    console.error('ERROR getFormsMainContent', error)
  }
}

async function getdisclaimer() {
  console.log('[getdisclaimer]  props.projectId: ', props.projectId)
  if (props.projectId === 0)
    return

  try {
    const fileName = 'IMPORTANT.md'
    const filePath = `ui%2Fforms%2F${encodeURIComponent(fileName)}/raw?ref=${props.branch}`
    const response = await git.getFileContent(props.projectId.toString(), filePath)

    console.log('getdisclaimerNote disclaimerNote response data:', response)
    disclaimerNote.value = response.data
    console.log('[getdisclaimer] disclaimer Note : ', disclaimerNote)
    markdownContent.value = marked(disclaimerNote.value)
    console.log('[getdisclaimer] markdownContent : ', markdownContent)
    if (!localStorage.getItem(`noticeAcknowleged.${props.branch}`))
      dialog.value = true
  }
  catch (error) {
    console.error('ERROR getdisclaimerNote', error)
  }
}

// Function to close the dialog
const closeDialog = () => {
  dialog.value = false
  localStorage.setItem(`noticeAcknowleged.${props.branch}`, 'true')
}

const dialog = ref<boolean>(false)

onMounted(() => {
  getdisclaimer()
  getFormsMainContent()
})
</script>

<template>
  <!-- If there is an error, show the alert -->
  <VAlert
    v-if="isError"
    icon="tabler-info-circle"
    type="error"
    title="ERROR!"
    :text="errorMessage"
    closable
  />

  <!-- Launch Pipeline Setup Form component -->

  <PipelineSetupFormComponent
    v-else
    :group-id="groupId"
    :id-project="projectId"
    :file-content-data="fileContentData"
    :branch="branch"
    :route="route"
  />

  <template>
    <div class="pa-4 text-center">
      <!-- The v-dialog will be automatically opened when the component is mounted -->
      <VDialog
        v-model="dialog"
        max-width="800"
        persistent
      >
        <template #activator="{ on, attrs }" />

        <VCard>
          <!-- v-card-title class="headline">IMPORTANT NOTES</v-card-title -->

          <VCardText>
            <div v-html="markdownContent" />
          </VCardText>

          <VCardActions>
            <VSpacer />
            <VBtn
              color="primary"
              variant="outlined"
              @click="closeDialog"
            >
              Acknowleged
            </VBtn>
          </VCardActions>
        </VCard>
      </VDialog>
    </div>
  </template>
</template>
